hdu 1973 Prime Path

题目连接

http://acm.hdu.edu.cn/showproblem.php?pid=1973

Prime Path

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
—I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
—In fact, I do. You see, there is this programming contest going on. . .

Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

bfs。。。

 #include<algorithm>
#include<iostream>
#include<cstdlib>
#include<cstring>
#include<cstdio>
#include<vector>
#include<queue>
#include<map>
using std::cin;
using std::cout;
using std::endl;
using std::find;
using std::sort;
using std::map;
using std::pair;
using std::queue;
using std::vector;
using std::reverse;
#define pb(e) push_back(e)
#define sz(c) (int)(c).size()
#define mp(a, b) make_pair(a, b)
#define all(c) (c).begin(), (c).end()
#define iter(c) decltype((c).begin())
#define cls(arr,val) memset(arr,val,sizeof(arr))
#define cpresent(c, e) (find(all(c), (e)) != (c).end())
#define rep(i, n) for (int i = 0; i < (int)(n); i++)
#define tr(c, i) for (iter(c) i = (c).begin(); i != (c).end(); ++i)
const int Max_N = ;
typedef unsigned long long ull;
int start, end;
namespace work {
struct Node {
int v, s;
Node(int i = , int j = ) :v(i), s(j) {}
};
bool vis[Max_N], Prime[Max_N];
inline bool isPrime(int n) {
for (int i = ; (ull)i * i <= n; i++) {
if ( == n % i) return false;
}
return n != ;
}
inline void init() {
for (int i = ; i < Max_N; i++) {
Prime[i] = isPrime(i);
}
}
inline void bfs() {
char buf[], str[];
cls(vis, false);
queue<Node> que;
que.push(Node(start, ));
vis[start] = true;
while (!que.empty()) {
Node tmp = que.front(); que.pop();
if (tmp.v == end) { printf("%d\n", tmp.s); return; }
sprintf(buf, "%d", tmp.v);
reverse(buf, buf + );
for (int i = ; buf[i] != '\0'; i++) {
rep(j, ) {
strcpy(str, buf);
str[i] = j + '';
reverse(str, str + );
int v = atoi(str);
if (vis[v] || !Prime[v]) continue;
que.push(Node(v, tmp.s + ));
vis[v] = true;
}
}
}
puts("Impossible");
}
}
int main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
freopen("out.txt", "w+", stdout);
#endif
int t;
work::init();
scanf("%d", &t);
while (t--) {
scanf("%d %d", &start, &end);
work::bfs();
}
return ;
}
上一篇:直接存储器存取(DMA)


下一篇:StackExchange.Redis 异步超时解决方案